# Generated by Django 4.1.7 on 2023-03-20 16:34

import django.db.models.deletion
from django.db import connection, migrations, models

import applications.models


def set_fields(apps, schema_editor):
    with connection.cursor() as cursor:
        Application = apps.get_model("applications", "Application")
        if Application.objects.filter(volunteer=None).exists():
            raise AssertionError(
                "Expected all applications to have volunteers at this point, something went wrong"
            )
        cursor.execute(
            """
            UPDATE applications_sarapplication as sa
                SET created = a.created,
                    volunteer_id = v.id
            FROM
                     applications_application as a
                JOIN volunteers_volunteer as v
                  ON v.application_id = a.id
            WHERE sa.application_id = a.id
            """
        )


class Migration(migrations.Migration):
    dependencies = [
        ("applications", "0044_application_removal_3_move_comments"),
    ]

    operations = [
        migrations.AddField(
            model_name="sarapplication",
            name="created",
            field=models.DateTimeField(default=applications.models.now),
        ),
        migrations.AddField(
            model_name="sarapplication",
            name="volunteer",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="volunteers.volunteer",
            ),
        ),
        migrations.RunPython(set_fields),
        migrations.AlterField(
            model_name="sarapplication",
            name="volunteer",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                to="volunteers.volunteer",
            ),
        ),
        migrations.AlterField(
            model_name="sarapplication",
            name="id",
            field=models.AutoField(primary_key=True, serialize=False),
        ),
    ]
